﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace PolygonToPoint
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            DialogResult DR = openFileDialog.ShowDialog();
            if(DR == DialogResult.OK)
            {
                tbInputSHP.Text = openFileDialog.FileName;
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            DialogResult DR = saveFileDialog.ShowDialog();
            if(DR == DialogResult.OK)
            {
                tbOutputSHP.Text = saveFileDialog.FileName;
            }
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private bool AllParamsValid()
        {
            if (tbInputSHP.Text.Length == 0)
            {
                MessageBox.Show("Set Polygon SHP File.");
                return false;
            }

            if (tbOutputSHP.Text.Length == 0)
            {
                MessageBox.Show("Set Output SHP File.");
                return false;
            }

            return true;
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            if(AllParamsValid())
            {
                bool bExisted = axXr1.Layers.IsLayerExist("map");
                if (bExisted) axXr1.Layers.RemoveLayer("map");

                axXr1.Layers.AddShapeMapLayer("map", openFileDialog.FileName);
                axXr1.WaitForAllConnections();

                XrMapLib.IShapeMapLayer lyr = axXr1.Layers.GetLayerAsShapeMap("map");
                XrMapLib.IShapeTable Tbl = lyr.ShapeTable;
                if(Tbl.ShapeType != XrMapLib.XrShapeTypeEnum.XrPolygon)
                {
                    MessageBox.Show("Input SHP is not Polygon Geometry.");
                    return;
                }

                XrMapLib.FieldSetDefine FSD = new XrMapLib.FieldSetDefine();
                FSD.AddIntegerField("__ID__", 8);

                XrMapLib.Tool tool = new XrMapLib.Tool();

                XrMapLib.EsriShpFileHandler SFH = tool.CreateEsriShpFileHandler(tbOutputSHP.Text, XrMapLib.XrShapeTypeEnum.XrPoint, FSD);
                if (SFH == null)
                {
                    MessageBox.Show("Error: Creating shp file");
                    return;
                }

                int FID = 0;
                XrMapLib.ValueList VL = new XrMapLib.ValueList();
                XrMapLib.IShapeRow row = null;
                progressBar.Style = ProgressBarStyle.Marquee;
                while ((row = Tbl.GetRow(FID)) != null)
                {
                    if (row.Load())
                    {
                        XrMapLib.Coordinate pt = null;
                        if (rbCentroid.Checked)
                        {
                            pt = row.Centroid;
                        }
                        else
                        {
                            pt = row.ToSpatialOperator().InnerPoint;
                        }

                        VL.Clear();
                        VL.AddByInteger(FID);   
                        SFH.AddPoint(pt.X, pt.Y, VL);  

                        row.Unload();
                        FID++;
                    }
                    else
                    {
                        MessageBox.Show("Input SHP is broken.");
                        break;
                    }
                }
                progressBar.Style = ProgressBarStyle.Blocks;

                SFH.Close();

                MessageBox.Show("Completed");
            }
        }
    }
}